// Library Definations
#include "B902AA.h"

// Software Definations
#define 	UART_Terminal		Serial1
#define 	UART_Terminal_Baud	115200

// Global Definations
#define 	DIAGNOSTIC 		true

void setup() {

	// Begin I2C Communication
	Wire.begin();

	// Terminal Communication Start
	if (DIAGNOSTIC) UART_Terminal.begin(UART_Terminal_Baud);

	// B902AA Diagnostic
	B902AA.HardwareDiagnostic();

	// Gauge Initialize
	B902AA.Gauge_Initialize();

	// Print Diagnostic
	if (DIAGNOSTIC) {
		
		UART_Terminal.println(F("******************************************"));
		UART_Terminal.println(F("**           B902AA Diagnostic          **"));
		UART_Terminal.println(F("******************************************"));
		
		// Control for I2C Multiplexer
		UART_Terminal.print(F("B902AA I2C Multiplexer (0x77)......."));
		if (B902AA.Diagnostic.Mux) {UART_Terminal.println(F("..[OK]"));} else {UART_Terminal.println(F("[FAIL]"));}

		// Control for I2C Temperature Sensor
		UART_Terminal.print(F("B902AA Temperature Sensor (0x40)...."));
		if (B902AA.Diagnostic.Mux) {UART_Terminal.println(F("..[OK]"));} else {UART_Terminal.println(F("[FAIL]"));}

		// Control for Internal LCD
		UART_Terminal.print(F("B902AA Internal LCD (0x27).........."));
		if (B902AA.Diagnostic.INTLCD) {UART_Terminal.println(F("..[OK]"));} else {UART_Terminal.println(F("[FAIL]"));}

		// Control for External LCD
		UART_Terminal.print(F("B902AA External LCD (0x27).........."));
		if (B902AA.Diagnostic.EXTLCD) {UART_Terminal.println(F("..[OK]"));} else {UART_Terminal.println(F("[FAIL]"));}

		// Control for Battery Gauge
		UART_Terminal.print(F("B902AA Battery Gauge (0x36)........."));
		if (B902AA.Diagnostic.EXTLCD) {UART_Terminal.println(F("..[OK]"));} else {UART_Terminal.println(F("[FAIL]"));}

	}

}

void loop() {


	// Blink
	B902AA.LED_Blink(0, 1, 1, 100);

}
